<template>
  <div>
    <Ariane
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />

    <div class="trunk">
      <div class="library_heading heading--library">
        <h1 class="heading--xl heading--primary heading--uppercase"></h1>
      </div>
    </div>

    <div class="trunk">
      <div v-if="!isLoading">
        <div class="user user-header" style>
          <div class="user_image">
            <img
              :src="getAvatarUrl"
              :alt="user.login"
              class="banner-serie_image responsively-lazy"
            />
          </div>
          <div class="user_text">
            <div class="user_title">
              <span class="user_login heading--lg heading--primary">
                {{ user.login }}
              </span>
              <div v-if="user.public" style="display: inline">
                <span v-if="user.public.age > 0" class="user_age text--medium">{{
                  $tc('profile.yearold', user.public.age, {
                    count: user.public.age
                  })
                }}</span>
                <span
                  v-if="user.public.isSuperReader"
                  class="user_role text text--sm"
                  :class="{
                    'text--tertiary': isSubscription,
                    'text--secondary': !isSubscription
                  }"
                  >{{ $t('followers.superreader') }}</span
                >
              </div>
              <div v-if="user.public">
                <span class="text text--md">
                  {{
                    $tc('followers.followers', user.public.followers, {
                      count: user.public.followers
                    })
                  }}
                  |
                  {{
                    $tc('followers.followees', user.public.followees, {
                      count: user.public.followees
                    })
                  }}
                </span>
                <div
                  class="text text--sm"
                  v-html="user.public.description"
                ></div>
                <div class="serie_meta margin--b-20">
                  <ul>
                    <li v-for="shelf in user.public.shelves" :key="shelf.id">
                      <NuxtLink
                        :to="
                          localePath({
                            name: 'catalog-shelf',
                            params: { shelf: shelf.slug }
                          })
                        "
                        >{{ shelf.name }}</NuxtLink
                      >
                    </li>
                    <li v-for="genre in user.public.genres" :key="genre.id">
                      <NuxtLink
                        :to="
                          localePath({
                            name: 'catalog-shelf-genre',
                            params: {
                              shelf: genre.shelf,
                              genre: genre.slug
                            }
                          })
                        "
                        >{{ genre.name }}</NuxtLink
                      >
                    </li>
                  </ul>
                </div>
              </div>
            </div>
          </div>
          <div v-if="user.isSelf || user.public" class="user_infos">
            <a
              v-if="user.isSelf"
              class="button button-follow button_md button_full"
              :href="getProfileURL()"
              >{{ $t('profile.edit') }}</a
            >
            <a
              v-else-if="user.isFollowee"
              class="button button-follow button_md button_shape"
              @click="followUser(user)"
              >{{ $t('followers.unfollow') }}</a
            >
            <a
              v-else
              class="button button-follow button_md button_full"
              @click="followUser(user)"
              >{{ $t('followers.follow') }}</a
            >
          </div>
        </div>

        <div v-if="user.public">
          <div class="user_statistics">
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/albums.svg')" />
              {{
                $tc('profile.album', stats.album_count, {
                  count: stats.album_count
                })
              }}
            </div>
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/extraits.svg')" />
              {{
                $tc('profile.preview', stats.read_preview, {
                  count: stats.read_preview
                })
              }}
            </div>
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/notes.svg')" />
              {{
                $tc('profile.rate', stats.rate_count, {
                  count: stats.rate_count
                })
              }}
            </div>
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/avis.svg')" />
              {{
                $tc('profile.comment', stats.comment_count, {
                  count: stats.comment_count
                })
              }}
            </div>
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/pages.svg')" />
              {{
                $tc('profile.read', stats.read_page, { count: stats.read_page })
              }}
            </div>
            <div class="statistics_item text text--md text--primary text--bold">
              <img :src="require('~/assets/images/series.svg')" />
              {{
                $tc('profile.follow', stats.follow_serie, {
                  count: stats.follow_serie
                })
              }}
            </div>
          </div>
          <div class="heading heading--with-button trunk">
            <h2 class="heading--lg heading--primary">
              {{ $t('profile.thumbs') }}
            </h2>
            <NuxtLink
              v-if="user.public.thumbs.length > 0"
              class="button button_shape button_sm"
              :to="
                localePath({
                  name: 'userfavorite-id-mode',
                  params: { id: $route.params.id, mode: 'thumbs' }
                })
              "
              >{{ $t('findreaders.seeall') }}</NuxtLink
            >
          </div>

          <template v-if="user.public.thumbs.length > 0">
            <client-only>
              <slick-slide
                ref="slick"
                :options="slickOptions"
                :class="`${
                  user.public.thumbs && user.public.thumbs.length > 5
                    ? 'products-slider thumb trunk'
                    : 'no-serie'
                }`"
              >
                <ThumbAlbum
                  v-for="album of user.public.thumbs"
                  :key="album.id"
                  :album="album"
                />
              </slick-slide>
            </client-only>
          </template>
          <p v-else class="text--md empty-content_text">
            {{ $t('profile.nothumbs') }}
          </p>
        </div>

        <div v-if="user.public">
          <div class="heading heading--with-button trunk">
            <h2 class="heading--lg heading--primary">
              {{ $t('profile.rating') }}
            </h2>
            <NuxtLink
              class="button button_shape button_sm"
              :to="
                localePath({
                  name: 'ratings-id',
                  params: { id: user.id }
                })
              "
              >{{ $t('findreaders.seeall') }}</NuxtLink
            >
          </div>

          <Comments
            v-if="user.public.comments.length > 0"
            :comments="user.public.comments"
          />
          <p v-else class="text--md empty-content_text">
            {{ $t('profile.norating') }}
          </p>
        </div>

        <div v-if="user.public">
          <div class="heading heading--with-button trunk">
            <h2 class="heading--lg heading--primary">
              {{ $t('profile.followserie') }}
            </h2>
            <NuxtLink
              v-if="user.public.follow_serie.length > 0"
              class="button button_shape button_sm"
              :to="
                localePath({
                  name: 'userfavorite-id-mode',
                  params: { id: $route.params.id, mode: 'followserie' }
                })
              "
              >{{ $t('findreaders.seeall') }}</NuxtLink
            >
          </div>

          <div
            v-if="user.public.follow_serie.length > 0"
            :class="'products-slider follow trunk'"
          >
            <client-only>
              <slick-slide ref="slick" :options="slickOptions">
                <FollowSerie
                  v-for="serie of user.public.follow_serie"
                  :key="serie.id"
                  :serie="serie"
                />
              </slick-slide>
            </client-only>
          </div>
          <p v-else class="text--md empty-content_text">
            {{ $t('profile.nofollowserie') }}
          </p>
        </div>
      </div>

      <Loader v-else-if="isLoading" />

      <div
        v-if="!isLoading && !user.public && !user.isSelf"
        class="trunk empty-content margin--b-110"
      >
        <div class="empty-content_image">
          <img :src="require('~/assets/images/IconeNoFollow.svg')" alt="" />
        </div>
        <h3 class="heading--md empty-content_heading">
          {{ $t('profile.privatetitle') }}
        </h3>
        <p class="text--md empty-content_text">
          {{ $t('profile.privatesub') }}
        </p>
      </div>

      <div
        v-if="!isLoading && !user.public && user.isSelf"
        class="trunk empty-content margin--b-110"
      >
        <div class="empty-content_image">
          <img :src="require('~/assets/images/IconeNoFollow.svg')" alt="" />
        </div>
        <h3 class="heading--md empty-content_heading" style="color: #000000">
          {{ $t('followers.private_title') }}
        </h3>
        <p class="text--md empty-content_text" style="color: #000000">
          {{ $t('followers.private_body') }}
        </p>
        <a class="button button_full" @click="activateAccount()">{{
          $t('followers.private_button')
        }}</a>
      </div>
    </div>
  </div>
</template>

<script>
import Loader from '~/components/ui/Loader'
import Ariane from '~/components/ui/Ariane'
import ThumbAlbum from '~/components/ThumbAlbum'
import FollowSerie from '~/components/FollowSerie'
import Comments from '~/components/Comments'

export default {
  name: 'Profil',
  components: { Loader, Ariane, ThumbAlbum, FollowSerie, Comments },

  async fetch() {
    await this.loadProfile()
  },

  data() {
    return {
      user: [],
      stats: [],
      isLoading: false,
      breadcrumbs: [this.$t('breadcrumb.home'), this.$t('breadcrumb.profile')],
      params: ['/' + this.$i18n.locale + '/', null],
      slickOptions: {
        dots: false,
        infinite: true,
        slidesToShow: 6,
        slidesToScroll: 6,
        prevArrow: '<button type="button" class="slick-prev"></button>',
        nextArrow: '<button type="button" class="slick-next"></button>',
        lazyLoad: 'ondemand',
        responsive: [
          {
            breakpoint: 1024,
            settings: 'unslick'
          }
        ]
      }
    }
  },

  computed: {
    getAvatarUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/avatar/${this.user.id}-250x250.jpg`
    },

    isSubscription() {
      return true
    }
  },

  methods: {
    async loadProfile() {
      this.isLoading = true
      try {
        const data = await this.$api.profil(this.$route.params.id)

        // TEST:leave 3 items: data.user.public.thumbs = data.user.public.thumbs.slice(0, 3)

        this.user = data.user

        if ('stats' in data) this.stats = data.stats
      } finally {
        this.isLoading = false
      }
      /*
      this.$nextTick(
            function () {
              this.utils.loadSlick('.thumb')
              this.utils.loadSlick('.follow')
            }.bind(this)
          )
       */
    },

    followUser: function (user) {
      if (user.isFollowee) {
        this.fetch.GET(
          '/' + this.$i18n.locale + '/api/unfollow/user/' + user.id
        )
        user.isFollowee = false
        user.public.followers--
        this.$forceUpdate
      } else {
        this.fetch.GET('/' + this.$i18n.locale + '/api/follow/user/' + user.id)
        user.isFollowee = true
        user.public.followers++
        this.$forceUpdate
      }
    },
    getProfileURL: function () {
      return '/' + this.$i18n.locale + '/profil/edit'
    },
    activateAccount: function () {
      const item = this
      const params = new URLSearchParams()
      params.append('status', '1')
      this.axios
        .post(Routing.generate('izneo_front_profile_status'), params)
        .then((response) => {
          if (response.status == 200) {
            item.isPublic = true
            item.loadFollowers()
          }
        })
        .catch((error) => {
          console.log(error.response)
        })
    }
  },

  head() {
    return {
      titleTemplate: this.$t('breadcrumb.profile')
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/empty-content/empty-content.scss"
></style>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/products-slider/_products-slider.scss"
></style>

<style scoped lang="scss">
a,
.pagination_page,
.pagination_arrow,
.button,
.filters li {
  cursor: pointer;
}

.user {
  position: relative;
  pointer-events: auto !important;
}

.user-header {
  display: flex;
  max-width: inherit;
  align-items: stretch;
  margin-left: 0;
  width: 100%;
  margin: 0 0 20px;
  padding: 20px;
  background: #f8f8f8;

  .user_image {
    display: flex;
    align-items: center;
    padding: 20px;
    margin-bottom: 0;

    img {
      border-radius: 50%;
    }
  }

  .user_text {
    position: relative;
    padding-right: 20px;
    width: 100%;
  }

  .user_login {
    font-family: DINCond-Bold;
  }

  .user_title {
    line-height: 1.5;
    font-size: 30px;
    font-size: 1.875rem;
  }

  .user_infos {
    display: flex;
    flex-flow: column;

    .button-follow {
      min-width: 167px;
      text-align: center;
      margin: 5px;
    }
  }
}

.user_age {
  opacity: 0.5;
  font-size: 1.7rem;
  margin-left: 5px;
  font-family: DINCond-Regular;
}

.user_role {
  font-size: 1.2rem;
  margin-left: 5px;
  font-family: DINCond-Regular;
}

.user_statistics {
  display: flex;
  margin-bottom: 20px;
}

.statistics_item {
  width: 18%;
  text-align: center;
  font-family: DINCond-Bold;
}

.serie_meta ul li {
  background: #cccccc;
  margin-bottom: 10px;
  margin-right: 10px;
  color: #3e3e3e;
  font-size: 16px;
  line-height: 30px;
  display: inline-block;
}

@media (max-width: 767px) {
  .user-header {
    flex-direction: column;
  }

  .user_statistics {
    display: block;
  }

  .statistics_item {
    padding: 10px;
    width: 100%;
  }

  .serie_meta ul li {
    margin-right: 0px;
  }
}
</style>
